#include "mml.h"
#include <unistd.h>

/*----------------------------------------------------------------------
 */
static int con_make_sound(int vol, int freq, int dur)
	/* dur: ȯ(=960) */
{
	dur = tick2ms(dur);
	if(dur > 1999) dur = 1999;
	fprintf(g_info.tty_fp, "\033[10;%d]\033[11;%d]\a", freq, dur);
	return 0;
}


static int con_init(void)
{
	if(g_info.output_file == NULL)
		g_info.output_file = "/dev/tty";
	g_info.tty_fp = fopen(g_info.output_file, "wb");
	if(g_info.tty_fp == NULL)
		return 1;
	if(!isatty(fileno(g_info.tty_fp))) {
		fprintf(stderr, "error: %s is not a tty\n", g_info.output_file);
		return 1;
	}

	setvbuf(g_info.tty_fp, NULL, _IONBF, 0);
	play_info_init(&play_info[0], seqlist[0]);
	return 0;
}


static int con_close(void)
{
	fclose(g_info.tty_fp);
	return 0;
}

static void con_signal_handler(int sig)
{
	con_close();
	exit(0);
}


struct mml_op con_iface_op = {
	con_init,
	generic_monotone_play,
	con_close,
	con_make_sound,
	con_signal_handler
};
