#define EXTERN
#include "mml.h"

#include <signal.h>

int main(int argc, char *argv[])
{
	int i;
	FILE *fp;

	g_info.output_file = NULL;
	g_info.op_ary = NULL;

	for(i = 1; i < argc; i++) {
		if(argv[i][0] == '-' && argv[i][1] == 'i') {
#ifdef CONFIG_X11
			if(argv[i][2] == 'x')
				g_info.op_ary = &x11_iface_op;
#endif
#ifdef CONFIG_CONSOLE
			if(argv[i][2] == 'c')
				g_info.op_ary = &con_iface_op;
#endif
			continue;
		}

		if(argv[i][0] == '-' && argv[i][1] == 'f') {
			g_info.output_file = &argv[i][2];
			continue;
		}

		/* not option, input file */
		if((fp = fopen(argv[i], "r")) == NULL) {
			fprintf(stderr, "%s: cant open\n", argv[i]);
			return 1;
		}
		parse_init(fp);
		p_file();
		fclose(fp);
		break;
	}

	/* 󥿡եꤵʤν */
#ifdef CONFIG_X11
	if(g_info.op_ary == NULL)
		g_info.op_ary = &x11_iface_op;
#endif
#ifdef CONFIG_CONSOLE
	if(g_info.op_ary == NULL)
		g_info.op_ary = &con_iface_op;
#endif

	if(g_info.op_ary != NULL) {
		signal(SIGINT, g_info.op_ary->signal);
		if(g_info.op_ary->open() != 0) {
			fprintf(stderr, "error: device initialization failed\n");
			return 1;
		}
		g_info.op_ary->play();
		g_info.op_ary->close();
	}
		
	return 0;
}
