#include <stdio.h>
#include <glib.h>

#ifdef CONFIG_X11
#include <X11/Xlib.h>
#endif

#ifndef EXTERN
#define EXTERN
#endif

/*----------------------------------------------------------------------
 * 
 */

#define MAX_TRACK		16
#define MAX_GATE_RATIO		128
#define MAX_VOLUME		128
#define WHOLE_NOTE_LENGTH	960
#define QUATER_NOTE_LENGTH	(960 / 4)

#define DEFAULT_LENGTH		QUATER_NOTE_LENGTH
#define DEFAULT_OCTAVE		4
#define DEFAULT_GATE_RATIO	MAX_GATE_RATIO
#define DEFAULT_VOLUME		100

/*----------------------------------------------------------------------
 * ǡ
 */

/* note_t: 1ĤǼ빽¤ */
typedef struct{
	/* Ǥμ */
	unsigned char kind;
#define NK_NOTE 'n'
#define NK_REST 'r'
#define NK_VOL 'v'
#define NK_QUANT 'q'
#define NK_PROG 'p'

	/* ̤˰¸
	 * NK_NOTE 'n'	0 < val < 108
	 *    (CBФ{0-11} + 12 * )
	 * NK_VOL 'v'	0 <= val < 128
	 * NK_QUANT 'q'	0 <= val < 128
	 * NK_PROG 'p'	0 <= val < 128
	 */
	unsigned char val;

	/* 960Ȥȯ */
	int length;
} note_t;

/* 󥹤ݻ */
EXTERN GList *all_seq_list;

/*
 * seqlist[track_no]ϡΥȥåǱդ륷󥹤ΥꥹȤݻ
 */
EXTERN GList *seqlist[MAX_TRACK];
EXTERN gint seqlist_idx;


/*----------------------------------------------------------------------
 * ѥǡ
 */
struct mml_op {
	int (*open)(void);
	int (*play)(void);
	int (*close)(void);
	int (*make_sound)(int, int, int);
	void (*signal)(int);
};


EXTERN struct global_info {
	int tempo;

	char *output_file;
	struct mml_op *op_ary;

#ifdef CONFIG_X11
	Display *x11_display;
	int bell_percent;
	unsigned bell_pitch, bell_duration;
#endif
#ifdef CONFIG_CONSOLE
	FILE *tty_fp;
#endif
#ifdef CONFIG_SMF
#endif
} g_info;


EXTERN struct play_info {
	int volume;
	int quant;
	GList *seq_ptr;
	GList *note_ptr;
} play_info[MAX_TRACK];


#ifdef CONFIG_X11
extern struct mml_op x11_iface_op;
#endif
#ifdef CONFIG_CONSOLE
extern struct mml_op con_iface_op;
#endif
#ifdef CONFIG_SMF
#endif



/*----------------------------------------------------------------------
 */
/* parse.c */
void p_file(void);
void parse_init(FILE *ifp);

/* play_util.c */
int frequency(int note_val);
int tick2ms(int tick);
void do_wait(int dur);
void play_info_init(struct play_info *info, GList *trk);
void play_info_proceed(struct play_info *info);
int generic_monotone_play(void);
